﻿package demo.app
{
	public class Constants
	{
		// Number of pixels in a Meter (Usually between 10 and 30).
		// The closer to 1, the more accurate. And more processor intensive.
		public static const PHYS_SCALE:Number = 10; 
		
		// Restitution is used to make objects bounce (usually set to be between 0 and 1).
		// 0 means the ball won't bounce. 1 means the ball's velocity will be exactly reflected. 
		public static const RESTITUTION:Number = 0.6;
		
		// Friction is used to make objects slide along each other (usually set to be between 0 and 1).
		// 0 turns off friction and a value of one makes the friction strong. 
		public static const FRICTION:Number = 0.6;
		
		// How many physical calculations per timestep.
		// Usually 1 / 15 or 1 / 60.
		public static const TIMESTEP:Number = 1.0 / 15.0;  
		
		// The suggested iteration count is 10.
		public static const ITERATIONS:Number = 10.0;
	}
}